Public Class frmMain

    Private Structure ZodiacRecord
        Dim SignDesc As String
        Dim House As String
        Dim Gemstone As String
        Dim NewAgeStone As String
        Dim Colors As String
        Dim OppositeSign As String
        Dim LeastCompat As String
        Dim RulingPlanet As String
        Dim Element As String
        Dim Anatomy As String
        Dim Flower As String
        Dim MostCompat As String
        Dim TarotCard As String
        Dim PositiveChars As String
        Dim NegativeChars As String
    End Structure

    Private maudtZodiacRec(0 To 11) As ZodiacRecord

    Private mintRowStart As Integer
    Private mintColStart As Integer


    Private Sub frmMain_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        Dim intZFileNbr As Integer
        Dim strFileName As String
        Dim intSignX As Integer

        intZFileNbr = FreeFile()
        strFileName = My.Application.Info.DirectoryPath & "\NewZodiac.txt"

        FileOpen(intZFileNbr, strFileName, OpenMode.Input)

        intSignX = -1

        Do Until EOF(intZFileNbr)
            intSignX = intSignX + 1
            With maudtZodiacRec(intSignX)
                Input(intZFileNbr, .SignDesc)
                Input(intZFileNbr, .House)
                Input(intZFileNbr, .Gemstone)
                Input(intZFileNbr, .NewAgeStone)
                Input(intZFileNbr, .Colors)
                Input(intZFileNbr, .OppositeSign)
                Input(intZFileNbr, .LeastCompat)
                Input(intZFileNbr, .RulingPlanet)
                Input(intZFileNbr, .Element)
                Input(intZFileNbr, .Anatomy)
                Input(intZFileNbr, .Flower)
                Input(intZFileNbr, .MostCompat)
                Input(intZFileNbr, .TarotCard)
                Input(intZFileNbr, .PositiveChars)
                Input(intZFileNbr, .NegativeChars)
            End With
        Loop

        FileClose(intZFileNbr)

        mintRowStart = 1
        mintColStart = 2
        SetColumnHeaders()
        DisplayZodiacData()

    End Sub

    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        Me.Close()
    End Sub

    Private Sub hsbZGrid_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles hsbZGrid.ValueChanged


        mintColStart = hsbZGrid.Value

        SetColumnHeaders()

        DisplayZodiacData()

    End Sub

    Private Sub vsbZGrid_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles vsbZGrid.ValueChanged

        mintRowStart = vsbZGrid.Value

        DisplayZodiacData()

    End Sub


    Private Sub SetColumnHeaders()

        Select Case mintColStart
            Case 2
                lblColHdr1.Text = "House"
                lblColHdr2.Text = "Gemstone"
                lblColHdr3.Text = "New Age Stone"
            Case 3
                lblColHdr1.Text = "Gemstone"
                lblColHdr2.Text = "New Age Stone"
                lblColHdr3.Text = "Colors"
            Case 4
                lblColHdr1.Text = "New Age Stone"
                lblColHdr2.Text = "Colors"
                lblColHdr3.Text = "Opposite Sign"
            Case 5
                lblColHdr1.Text = "Colors"
                lblColHdr2.Text = "Opposite Sign"
                lblColHdr3.Text = "Least Compatible Signs"
            Case 6
                lblColHdr1.Text = "Opposite Sign"
                lblColHdr2.Text = "Least Compatible Signs"
                lblColHdr3.Text = "Ruling Planet"
            Case 7
                lblColHdr1.Text = "Least Compatible Signs"
                lblColHdr2.Text = "Ruling Planet"
                lblColHdr3.Text = "Element"
            Case 8
                lblColHdr1.Text = "Ruling Planet"
                lblColHdr2.Text = "Element"
                lblColHdr3.Text = "Anatomy"
            Case 9
                lblColHdr1.Text = "Element"
                lblColHdr2.Text = "Anatomy"
                lblColHdr3.Text = "Flower"
            Case 10
                lblColHdr1.Text = "Anatomy"
                lblColHdr2.Text = "Flower"
                lblColHdr3.Text = "Most Compatible Signs"
            Case 11
                lblColHdr1.Text = "Flower"
                lblColHdr2.Text = "Most Compatible Signs"
                lblColHdr3.Text = "Tarot Card"
            Case 12
                lblColHdr1.Text = "Most Compatible Signs"
                lblColHdr2.Text = "Tarot Card"
                lblColHdr3.Text = "Positive Characteristics"
            Case 13
                lblColHdr1.Text = "Tarot Card"
                lblColHdr2.Text = "Positive Characteristics"
                lblColHdr3.Text = "Negative Characteristics"
        End Select

    End Sub

    Private Sub DisplayZodiacData()

        Dim intX As Integer
        Dim intRecordIndex As Integer
        Dim picSign As PictureBox
        Dim lblCell1 As Label
        Dim lblCell2 As Label
        Dim lblCell3 As Label
        Dim lblCell4 As Label

        intRecordIndex = mintRowStart - 1

        For intX = 0 To 6
            picSign = DirectCast(GetControlByName(Me, "picSign" & intX), PictureBox)
            lblCell1 = DirectCast(GetControlByName(Me, "lblCell1_" & intX), Label)
            lblCell2 = DirectCast(GetControlByName(Me, "lblCell2_" & intX), Label)
            lblCell3 = DirectCast(GetControlByName(Me, "lblCell3_" & intX), Label)
            lblCell4 = DirectCast(GetControlByName(Me, "lblCell4_" & intX), Label)
            With maudtZodiacRec(intRecordIndex)
                lblCell1.Text = .SignDesc
                picSign.Image = imlSigns.Images(intRecordIndex)
                Select Case mintColStart
                    Case 2
                        lblCell2.Text = .House
                        lblCell3.Text = .Gemstone
                        lblCell4.Text = .NewAgeStone
                    Case 3
                        lblCell2.Text = .Gemstone
                        lblCell3.Text = .NewAgeStone
                        lblCell4.Text = .Colors
                    Case 4
                        lblCell2.Text = .NewAgeStone
                        lblCell3.Text = .Colors
                        lblCell4.Text = .OppositeSign
                    Case 5
                        lblCell2.Text = .Colors
                        lblCell3.Text = .OppositeSign
                        lblCell4.Text = .LeastCompat
                    Case 6
                        lblCell2.Text = .OppositeSign
                        lblCell3.Text = .LeastCompat
                        lblCell4.Text = .RulingPlanet
                    Case 7
                        lblCell2.Text = .LeastCompat
                        lblCell3.Text = .RulingPlanet
                        lblCell4.Text = .Element
                    Case 8
                        lblCell2.Text = .RulingPlanet
                        lblCell3.Text = .Element
                        lblCell4.Text = .Anatomy
                    Case 9
                        lblCell2.Text = .Element
                        lblCell3.Text = .Anatomy
                        lblCell4.Text = .Flower
                    Case 10
                        lblCell2.Text = .Anatomy
                        lblCell3.Text = .Flower
                        lblCell4.Text = .MostCompat
                    Case 11
                        lblCell2.Text = .Flower
                        lblCell3.Text = .MostCompat
                        lblCell4.Text = .TarotCard
                    Case 12
                        lblCell2.Text = .MostCompat
                        lblCell3.Text = .TarotCard
                        lblCell4.Text = .PositiveChars
                    Case 13
                        lblCell2.Text = .TarotCard
                        lblCell3.Text = .PositiveChars
                        lblCell4.Text = .NegativeChars
                End Select
            End With
            intRecordIndex = intRecordIndex + 1
        Next

    End Sub

    Private Function GetControlByName(ByVal pobjParent As Control, _
                                      ByVal pstrCtlName As String) _
    As Control

        Dim objCtl As Control

        For Each objCtl In pobjParent.Controls
            If objCtl.Name = pstrCtlName Then
                Return (objCtl)
            End If
        Next

        ' if control is not found
        Return Nothing

    End Function

End Class